/*
 *	main.c
 *
 *	Kplǂ
 *	Copyright (C) 2002 Naoyuki Sawa
 *
 *	* Mon Nov 24 00:00:00 JST 2002 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

//#define USE_MUSIC /* yCugꍇ́ÃV{`Ă */
#ifdef USE_MUSIC
#include "instdef.c"
#define music_play(data) do { music_stop(); PlayMusic((unsigned char*)(data)); } while(0)
#define music_stop() do { StopMusic(); sound_stop(music_wch); } while(0)
#else /*USE_MUSIC*/
#define music_play(data) ((void)0)
#define music_stop() ((void)0)
#endif /*USE_MUSIC*/

//#define V_SCREEN /* cʃ[hgꍇ́ÃV{`Ă */
#ifdef V_SCREEN
#undef DISP_X
#undef DISP_Y
#define DISP_X	 88
#define DISP_Y	128
#endif /*V_SCREEN*/

/* MODf[^(->data.c) */
extern const unsigned char GAME[];
extern const unsigned char GAME2[];
extern const unsigned char CLEAR[];
extern const unsigned char GAMEOVER[];
/* EyC̃Lf[^ */
extern const unsigned char ECLEA[];
extern const unsigned char FLAPPE[];
extern const unsigned char JAM[];
extern const unsigned char KONOMI[];
extern const unsigned char P1ECE[];
extern const unsigned char TIPS[];

/* WAVf[^ */
extern const unsigned char PANMOV[];	/* ch.1 */
extern const unsigned char PANERA[];	/* ch.1 */
extern const unsigned char PANMIS[];	/* ch.1 */
extern const unsigned char PANDN[];	/* ch.2 */
extern const unsigned char PANUP[];	/* ch.2 */
extern const unsigned char NXTWRN[];	/* ch.2 */
extern const unsigned char BLKEXP[];	/* ch.3 */

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

#define RND(a, b)	((a) + rand() % ((b) - (a) + 1))	/* a`b̗(b܂) */


#define MAX_COLOR	 4	/* pl̍őF */
#define PANEL_COLS	 6	/* pľ */
#define PANEL_ROWS	11	/* pl̍s(NEXT܂܂) */
typedef struct _PANEL {
	         char color;	/* -1:Z/0:J[\/1`MAX_COLOR:pl */
	unsigned char mark;	/* ėp}[N */
} PANEL;

#define BLOCK_COLS	PANEL_COLS	/* ubŇ */
#define BLOCK_ROWS	12		/* ubN̍s(NEXT܂܂) */
typedef struct _BLOCK {
	/* ubN */
	unsigned char cnt;		/* ubN */
	unsigned char expl;		/* JE^(0:Ȃ/1`:) */
	/* ~TC */
	unsigned char mis_stock;	/* ҂~TC */
	unsigned char mis_stat;		/* ~TC(0:o/1:ҋ@/2:) */
	short mis_pos;			/* ~TCʒu(V䑊΁E8.8bit) */
	short mis_speed;		/* x(8.8bit) */
} BLOCK;

typedef struct _GI {
	int score;		/* XRA */
	int round;		/* Ehԍ(1`) */
	int life;		/* c@(݂܂) */

	/* xp[^ */
	const struct _ROUND* round_p; /* ݂̃Eh\̂ւ̃|C^ */
	int time;		/* Eh^C} */
	short next_time;	/* NEXTploԊu */

	/* yCɊ֘AtB[h */
	int phase;		/* tF[Y(PHASE_*) */
	int cnt;		/* ėpJE^ */
	int next_cnt;		/* NEXTploJE^ */
	int cursor_col;		/* J[\ʒu() */
	int cursor_row;		/*             (s) */
	PANEL panel[PANEL_ROWS][PANEL_COLS];	/* pl */
	PANEL next[PANEL_COLS];			/* NEXTpl */

	/* EyCɊ֘AtB[h */
	int block_top;			/* ubNJns */
	int block_rows;			/* ubNs */
	BLOCK block[BLOCK_COLS];	/* ubNȅ */
	PIECE_BMP pinup;		/* sibv摜 */

	/* \ */
	int face;			/* ԍ(0`11) */
	int face_cnt;			/* ύXpJE^ */
} GI;
/* ROUND\GAMEOVER\̓tF[YɊ܂݂܂ */
enum {
	PHASE_NORMAL,		/* ʏ */
	PHASE_MOVE_LF,		/* ړ() */
	PHASE_MOVE_RI,		/* ړ(E) */
	PHASE_MOVE_UP,		/* ړ() */
	PHASE_MOVE_DN,		/* ړ() */
	PHASE_ERASE,		/* Œ */
};

const unsigned char face_normal[] = {0,1,3,4,11}; /* ʏ펞̊ */
const unsigned char face_erase[] = {1,2,11}; /* plŎ̊ */
const unsigned char face_clear[] = {2}; /* EhNÅ */
const unsigned char face_warn[] = {5,7,8,10}; /* plx̊ */
const unsigned char face_miss[] = {6,7,8,9,10}; /* ~X̊ */
#define face_sel(f)	(f)[RND(0, sizeof (f) / sizeof (*f) - 1)]

#define NEXT_WARN_TIME	SEC(0.66)	/* NEXTplỏbOxH */

typedef struct _ROUND {
	/* ^C~Oݒ */
	short four_time;	/* OFlFύX(0Ȃŏ) */
	short next_init;	/* オԊȕl */
	short next_step;	/* 񂹂オ閈ɂオԊuHbȂ */
	short next_min;		/* オԊu̍ŏl */
	/* sibvݒ */
	const unsigned char* pinup;	/* sAbvC[W */
	const unsigned char block_rows;	/* ubNs(6/8/10/12) */
} ROUND;
#define ROUND_FOUR_TIME		(gi.round_p->four_time)
#define ROUND_NEXT_INIT		(gi.round_p->next_init)
#define ROUND_NEXT_STEP		(gi.round_p->next_step)
#define ROUND_NEXT_MIN		(gi.round_p->next_min)
#define ROUND_PINUP		(gi.round_p->pinup)
#define ROUND_BLOCK_ROWS	(gi.round_p->block_rows)
#define ROUND_COLOR		(gi.time < ROUND_FOUR_TIME ? 3 : 4)

#define MAX_ROUND	30
const ROUND round_tbl[MAX_ROUND + 1] = {
	{ -1 },
	/* 1`5 */
	{ SEC(60), SEC(10), SEC(0.05), SEC( 5), JAM,     6 },
	{ SEC(55), SEC(10), SEC(0.05), SEC( 5), ECLEA,   8 },
	{ SEC(50), SEC(10), SEC(0.05), SEC( 5), FLAPPE, 10 },
	{ SEC(45), SEC(10), SEC(0.05), SEC( 5), KONOMI, 12 },
	{ SEC(40), SEC( 9), SEC(0.10), SEC( 5), TIPS,    6 },
	{ SEC(35), SEC( 9), SEC(0.10), SEC( 4), JAM,     8 },
	{ SEC(30), SEC( 9), SEC(0.10), SEC( 4), ECLEA,  10 },
	{ SEC(25), SEC( 9), SEC(0.10), SEC( 4), FLAPPE, 12 },
	{ SEC(20), SEC( 8), SEC(0.15), SEC( 4), KONOMI,  6 },
	{ SEC(15), SEC( 8), SEC(0.15), SEC( 4), TIPS,    8 },
	/* 11`15 */
	{ SEC(10), SEC( 8), SEC(0.15), SEC( 3), JAM,    10 },
	{ SEC( 5), SEC( 8), SEC(0.15), SEC( 3), ECLEA,  12 },
	{ SEC( 0), SEC( 7), SEC(0.20), SEC( 3), FLAPPE,  6 },
	{ SEC( 0), SEC( 7), SEC(0.20), SEC( 3), KONOMI,  8 },
	{ SEC( 0), SEC( 7), SEC(0.20), SEC( 3), TIPS,   10 },
	{ SEC( 0), SEC( 7), SEC(0.20), SEC( 2), JAM,    12 },
	{ SEC( 0), SEC( 6), SEC(0.25), SEC( 2), ECLEA,   6 },
	{ SEC( 0), SEC( 6), SEC(0.25), SEC( 2), FLAPPE,  8 },
	{ SEC( 0), SEC( 6), SEC(0.25), SEC( 2), KONOMI, 10 },
	{ SEC( 0), SEC( 6), SEC(0.25), SEC( 2), TIPS,   12 },
	/* 21`25 */
	{ SEC( 0), SEC( 5), SEC(0.30), SEC( 1), JAM,     6 },
	{ SEC( 0), SEC( 5), SEC(0.30), SEC( 1), ECLEA,   8 },
	{ SEC( 0), SEC( 5), SEC(0.30), SEC( 1), FLAPPE, 10 },
	{ SEC( 0), SEC( 5), SEC(0.30), SEC( 1), KONOMI, 12 },
	{ SEC( 0), SEC( 4), SEC(0.35), SEC( 1), TIPS,    6 },
	{ SEC( 0), SEC( 4), SEC(0.35), SEC( 1), JAM,     8 },
	{ SEC( 0), SEC( 4), SEC(0.35), SEC( 1), ECLEA,  10 },
	{ SEC( 0), SEC( 4), SEC(0.35), SEC( 1), FLAPPE, 12 },
	{ SEC( 0), SEC( 3), SEC(0.40), SEC( 1), KONOMI, 12 },
	{ SEC( 0), SEC( 2), SEC(0.50), SEC( 1), P1ECE,  12 },
};

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER render;				/* zVRAMւ̕` */

int now;				/* O[o^C} */
int joy;				/* pbh */

extern const unsigned char PAT[];
extern const unsigned char BG[];
TEXTURE pat;
TEXTURE bg;
TEXTURE pat2; /* patƓrbg}bvA}XNȂ */

int hiscore;
int round_sel = 1;
GI gi;

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
int demo();
void game();
void game_init();
void round_init();
void next_gen();
int next_in();
void round_demo();
void gameover_demo();
int chain_count(int col, int row, int dir);
int erase_check();
int erase_end();
void mark_clr(unsigned char mark);
int missile_work();
void field_disp();
void miss_demo();
void clear_demo();

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo() != 0) break;
		game();
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
#ifdef V_SCREEN
	pceLCDSetBuffer(_def_vbuff);
#else /*V_SCREEN*/
	pceLCDSetBuffer(vbuff);
#endif /*V_SCREEN*/
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE);
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init(&render, &surface, 0, 0, 0, 0, 0, 0, 0);

#ifdef USE_MUSIC
	/* yCu܂B */
	InitMusic();
#endif /*USE_MUSIC*/

	/* N[Abv֐o^B */
	atexit(app_exit);

/*{{AvP[VL̏*/
	srand(pceTimerGetCount());
	/* rbg}bvB */
	texture_init(&pat, PAT);
	texture_init(&bg, BG);
	pat2 = pat; /* patƓrbg}bvA}XNȂ */
	pat2.header.mask = 0;
/*}}AvP[VL̏*/
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
/*{{AvP[VL̃N[Abv*/
	mod_stop(); /* 킷ȂŁI킷ȂŁI킷ȂŁI */
/*}}AvP[VL̃N[Abv*/
#ifdef USE_MUSIC
	/* mɉyt~܂B
	 * TEh̒~̓CupceAppExit()ōsĂ̂ŁA
	 * ł͕Kv܂B
	 */
	StopMusic();
#endif /*USE_MUSIC*/
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_FONT	0x80		/* PAUSEtHg         */
#define PAUSE_COLOR	0x130		/* PAUSEJ[(wip) */
//#define PAUSE_COLOR	0x203		/* PAUSEJ[(wip) */
#define PAUSE_STR	"PAUSE"		/* PAUSEbZ[W       */
#define PAUSE_W		(5 * 5 + 2)	/* PAUSEbZ[W̉ */
#define PAUSE_H		(10    + 2)	/* PAUSEbZ[W̏c */
#define PAUSE_X		((DISP_X - PAUSE_W) / 2) /* \ʒu */
#define PAUSE_Y		((DISP_Y - PAUSE_H) / 2) /* \ʒu */

	int pause, x, y;
	/* PAUSEbZ[Ẅ̃C[Wޔpobt@́A324oCgKvłB
	 * X^bNɎ̂͊댯łAstaticɎ̖̂ʂłB
	 * ŁAPAUSEɂ̂݃q[vmۂ邱Ƃɂ܂B
	 */
	//unsigned char save[PAUSE_H][PAUSE_W];
	unsigned char (*save)[PAUSE_W] = NULL/*x}*/;

	pause = 0;
	for(;;) {
#ifdef V_SCREEN
		{ /* vbuff(c)_def_vbuff()ϊ */
			unsigned char *dst, *src;
			dst = &_def_vbuff[0];     /* ]̉ʂ͍ォ瑖Jn܂ */
			src = &vbuff[DISP_X - 1]; /* ]̏cʂ͉Eォ瑖Jn܂ */
			for(x = DISP_X - 1; x >= 0; x--) {
				for(y = 0; y < DISP_Y; y++) {
					*dst = *src;
					dst += 1;      /* ʂEɑ܂ */
					src += DISP_X; /* cʂɑ܂ */
				}
				                            /* ʂ͊Ɏ̍sֈړĂ܂ */
				src -= DISP_X * DISP_Y + 1; /* cʂ̗̈ԏֈړ܂ */
			}
		}
#endif /*V_SCREEN*/
		pceLCDTrans();		/* ʍXV */
		yield();		/* VXe */
		joy = pcePadGet();	/* pbhԍXV */
#ifdef V_SCREEN
		joy = (joy & ~(PAD_LF | PAD_RI | PAD_UP | PAD_DN | /* cʗp͕ϊ */
			       TRG_LF | TRG_RI | TRG_UP | TRG_DN))
			| (joy & PAD_LF ? PAD_UP : 0)
			| (joy & PAD_RI ? PAD_DN : 0)
			| (joy & PAD_UP ? PAD_RI : 0)
			| (joy & PAD_DN ? PAD_LF : 0)
			| (joy & TRG_LF ? TRG_UP : 0)
			| (joy & TRG_RI ? TRG_DN : 0)
			| (joy & TRG_UP ? TRG_RI : 0)
			| (joy & TRG_DN ? TRG_LF : 0);
#endif /*V_SCREEN*/

		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause;	/* PAUSEԐ؂ւ */
			if(pause) {	/* PAUSE IN */
				/* PAUSEbZ[W\̃C[WޔB */
				save = (unsigned char (*)[PAUSE_W])malloc(PAUSE_W * PAUSE_H); /* C[Wޔpobt@m */
				if(save == NULL) DIE();
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						save[y][x] = vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)];
					}
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̃C[W𕜋AB */
				for(y = 0; y < PAUSE_H; y++) {
					for(x = 0; x < PAUSE_W; x++) {
						vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
					}
				}
				free(save); /* C[Wޔpobt@J */
			}
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(pceTimerGetCount() % 1000 < 750) {
			render_string_framed(&render, PAUSE_X, PAUSE_Y, PAUSE_STR, PAUSE_FONT, PAUSE_COLOR);
		} else {
			for(y = 0; y < PAUSE_H; y++) {
				for(x = 0; x < PAUSE_W; x++) {
					vbuff[DISP_X * (PAUSE_Y + y) + (PAUSE_X + x)] = save[y][x];
				}
			}
		}
	}
	now++;	/* O[o^C}XV */

#undef PAUSE_FONT
#undef PAUSE_COLOR
#undef PAUSE_STR
#undef PAUSE_W
#undef PAUSE_H
#undef PAUSE_X
#undef PAUSE_Y
}

/****************************************************************************
 *	demo
 ****************************************************************************/

int
demo()
{
	int i, x, y;

	pcePadSetTrigMode(PP_MODE_REPEAT); /* EhÎ߂ɈꎞIɃI[gs[g */
	for(;;) {
		schedule();

		/* X^[gHIH */
		if(joy & TRG_A     ) break;
		if(joy & TRG_SELECT) return -1;

		/* ʍĕ`ȂŃvvĝݓ_ł邽߁AʃNAɔI */
		memset(vbuff, 3, sizeof vbuff);

		/* JnxIB */
		if(joy & (TRG_LF | TRG_DN) && round_sel > 1        ) { round_sel--; sound_play(1, PANMOV); }
		if(joy & (TRG_RI | TRG_UP) && round_sel < MAX_ROUND) { round_sel++; sound_play(1, PANMOV); }

		/* ^Cg\B */
		x = (DISP_X - 8 * 9) / 2;
		y = 24;
		render_string_framed(&render, x, y, "MEGAPANEL", 1, 0x210);
		x = (DISP_X - 10 * 3) / 2;
		y += 14;
		render_string_framed(&render, x, y, "ǂ", 0, 0x210);

		/* XRA\B */
		x = 0;
		y = 0;
		render_string_framed(&render, x, y, "HISCORE", 0, 0x321);
		y += 10;
		render_printf_framed(&render, x, y, 0, 0x321, "%6d0", hiscore <= 999999 ? hiscore : 999999);
		x = DISP_X - 5 * 7 - 3;
		y = 0;
		render_string_framed(&render, x, y, "PLAYER1", 0, 0x321);
		y += 10;
		render_printf_framed(&render, x, y, 0, 0x321, "%6d0", gi.score <= 999999 ? gi.score : 999999);

		/* Jnx\B */
		x = (DISP_X - 5 * 12) / 2;
		y = DISP_Y - 10;
		render_printf_framed(&render, x, y, 0, 0x321, "< ROUND %2d >", round_sel);

		/* vvg\B */
		x = (DISP_X - 5 * 8) / 2;
		y = DISP_Y - 34;
		render_string_framed(&render, x, y, " A START", 0, 0x321);
		y += 10;
		render_string_framed(&render, x, y, "SEL EXIT", 0, 0x321);
	}
	pcePadSetTrigMode(PP_MODE_SINGLE); /* Q[̓I[gs[gItɖ߂܂ */

	/* BGMX^[gEvvg_ŁB */
	mod_play(GAME);
	for(i = 0; i < SEC(1.5); i++) {
		schedule();
		x = (DISP_X - 5 * 8) / 2;
		y = DISP_Y - 35;
		render_string_framed(&render, x, y, " A START", 0, i % SEC(0.5) < SEC(0.25) ? 0x333 : 0x321);
	}

	return 0;
}

/****************************************************************************
 *	game
 ****************************************************************************/

void
game()
{
	PANEL *panel, *panel2;
	int col, row, col2, row2, vx, vy, next_phase;

	game_init();
	for(;;) {
		round_init();
		round_demo();
		for(;;) {
			schedule();

			/* Փxp^C}JEgAbvB */
			gi.time++;

			/* NEXTubNoJEgAbvB */
			if(gi.next_cnt < gi.next_time) {
				gi.next_cnt++;
				if(gi.next_cnt == gi.next_time - NEXT_WARN_TIME) sound_play(2, NXTWRN);
			}

			/* Aj[VB */
			if(gi.face_cnt > 0) {
				gi.face_cnt--;
			} else {
				for(panel = &gi.panel[0][0], row = 0; row < 2; row++) { /* sɃplx */
					for(col = 0; col < PANEL_COLS; col++, panel++) {
						if(panel->color == -1) continue;
						if(!panel->mark) break;
					}
					if(col < PANEL_COLS) break;
				}
				if(row < 2) { /* x */
					gi.face = face_sel(face_warn);
					gi.face_cnt = SEC(1);
				} else { /* ʏ */
					gi.face = face_sel(face_normal);
					gi.face_cnt = SEC(1);
				}
			}

			switch(gi.phase) {
			case PHASE_NORMAL:
L10:
				/* NEXTubNoH */
				if((joy & (TRG_A | TRG_B)) ||
				   gi.next_cnt >= gi.next_time) {
					if(!next_in()) { /* os */
						/* ^CAEgɂołȂ΃~XB
						 * {^ɂov疳܂B
						 */
						if(gi.next_cnt >= gi.next_time) goto ROUND_MISS;
					} else { /* o */
						gi.next_cnt = 0;
						sound_play(2, PANUP);
						/* オԊuZB */
						gi.next_time -= ROUND_NEXT_STEP;
						if(gi.next_time < ROUND_NEXT_MIN) gi.next_time = ROUND_NEXT_MIN;
						/*  łH */
						if(erase_check()) {
							gi.phase = PHASE_ERASE;
							gi.cnt = 0;
							sound_play(1, PANERA);
							gi.face = face_sel(face_erase);
							gi.face_cnt = SEC(1);
							break; /* ړJn͔΂ */
						}
						/* ̂܂܈ړJn */
					}
				}
				/* ړJnH */
				next_phase = -1;
				vx = vy = 0; /* x} */
				if(joy & PAD_LF) {
					next_phase = PHASE_MOVE_LF;
					vx = 1;
				} else if(joy & PAD_RI) {
					next_phase = PHASE_MOVE_RI;
					vx = -1;
				} else if(joy & PAD_UP) {
					next_phase = PHASE_MOVE_UP;
					vy = 1;
				} else if(joy & PAD_DN) {
					next_phase = PHASE_MOVE_DN;
					vy = -1;
				}
				if(next_phase != -1) {
					col = gi.cursor_col;
					row = gi.cursor_row;
					col2 = col + vx;
					row2 = row + vy;
					if(0 <= col2 && col2 <= PANEL_COLS - 1 &&
					   0 <= row2 && row2 <= PANEL_ROWS - 1) {
						panel  = &gi.panel[row ][col ];
						panel2 = &gi.panel[row2][col2];
						if(panel2->color >= 1) {
							panel->color = panel2->color;
							panel->mark = 1;
							panel2->color = 0;
							panel2->mark = 1;
							gi.cursor_col = col2;
							gi.cursor_row = row2;
							gi.phase = next_phase;
							gi.cnt = 0;
							sound_play(1, PANMOV);
						}
					}
				}
				break;
			case PHASE_MOVE_LF:
			case PHASE_MOVE_RI:
			case PHASE_MOVE_UP:
			case PHASE_MOVE_DN:
				/* ړAj[VLZH */
				if(joy & (TRG_LF | TRG_RI | TRG_UP | TRG_DN)) {
					gi.cnt = 6 * 2;
				} else { /* ʏ̈ړAj[Vis */
					gi.cnt += 2;
				}
				if(gi.cnt >= 6 * 2) {
					mark_clr(-1); /* ړpl̃}[N */
					/*  łH */
					if(erase_check()) {
						gi.phase = PHASE_ERASE;
						gi.cnt = 0;
						sound_play(1, PANERA);
						gi.face = face_sel(face_erase);
						gi.face_cnt = SEC(1);
					} else {
						gi.phase = PHASE_NORMAL;
						gi.cnt = 0;
						/* ړAj[VLZȂAɃL[͏ցB */
						if(joy & (TRG_LF | TRG_RI | TRG_UP | TRG_DN)) goto L10;
					}
				}
				break;
			case PHASE_ERASE:
				/* ŊH */
				gi.cnt++;
				if(gi.cnt >= 4 * 2 + SEC(0.33)/*EFCg*/) {
					/* Ō㏈ijAH */
					if(erase_end()) { /*  */
						sound_play(2, PANDN);
						/* ɏłH */
						if(erase_check()) {
							gi.phase = PHASE_ERASE;
							gi.cnt = 0;
							sound_play(1, PANERA);
							gi.face = face_sel(face_erase);
							gi.face_cnt = SEC(1);
						} else {
							gi.phase = PHASE_NORMAL;
							gi.cnt = 0;
						}
					} else { /* Ȃ */
						gi.phase = PHASE_NORMAL;
						gi.cnt = 0;
					}
				}
				break;
			default:
				DIE();
			}

			/*{{BR}h*/
			if((joy & PAD_MASK) == (PAD_LF | PAD_RI | PAD_UP | PAD_DN | PAD_A | PAD_SELECT)) for(col = 0; col < BLOCK_COLS; col++) gi.block[col].cnt = 0;
			if((joy & PAD_MASK) == (PAD_LF | PAD_RI | PAD_UP | PAD_DN | PAD_B | PAD_SELECT)) goto ROUND_MISS;
			/*}}BR}h*/

			/* ~TCB */
			if(missile_work() == 0) goto ROUND_CLEAR;

			/* \XVB */
			field_disp();
		}
ROUND_CLEAR:
		gi.next_cnt = 0; /* NEXTx_ł~߂ */
		gi.phase = PHASE_NORMAL;
		mark_clr(-1);
		gi.face = face_sel(face_clear);
		/*gi.face_cnt = SEC(1); sv */
		clear_demo();
		gi.round++;
		continue;
ROUND_MISS:
		gi.next_cnt = 0; /* NEXTx_ł~߂ */
		gi.phase = PHASE_NORMAL;
		mark_clr(-1);
		gi.face = face_sel(face_miss);
		/*gi.face_cnt = SEC(1); sv */
		gi.life--;
		miss_demo();
		if(gi.life) continue;
		break; /* Q[I[o[ */
	}
	gameover_demo();
}

/****************************************************************************
 *	game_init
 ****************************************************************************/

void
game_init()
{
	memset(&gi, 0, sizeof gi);
	gi.round = round_sel;
	gi.life = 3;
}

/****************************************************************************
 *	round_init
 ****************************************************************************/

void
round_init()
{
#define MAX_RETRY	10

	int col, row, retry;
	PANEL* panel;
	BLOCK* block;

	/*--------------- Փx ---------------*/

	/* Eh\̂ւ̃|C^i[Ă܂B */
	if(gi.round < 1) DIE();
	if(gi.round <= MAX_ROUND) {
		gi.round_p = &round_tbl[gi.round];
	} else {
		gi.round_p = &round_tbl[MAX_ROUND];
	}

	gi.time = 0;
	gi.next_time = ROUND_NEXT_INIT;

	/*--------------- tF[Y ---------------*/

	gi.phase = PHASE_NORMAL;
	gi.cnt = 0;
	gi.next_cnt = 0;

	/*--------------- pl ---------------*/

	/* ܂ASZ𖳌(-1)ɂ܂B */
	memset(gi.panel, -1, sizeof gi.panel);

	/* Osɏpl𐶐܂B */
	for(panel = &gi.panel[PANEL_ROWS - 1][PANEL_COLS - 1], row = PANEL_ROWS - 1; row >= PANEL_ROWS - 3; row--) {
		for(col = PANEL_COLS - 1; col >= 0; col--, panel--) {
			for(retry = 0; retry < MAX_RETRY; retry++) {
				panel->color = RND(1, ROUND_COLOR);
				mark_clr(-1);
				if(chain_count(col, row, 0) < 3 && /* ʕ̌Ȃ̂ł̊Ԃłmark_clr()sv */
				   chain_count(col, row, 1) < 3) break;
			}
		}
	}
	mark_clr(-1); /* Ōchain_count()̃}[NNAAYꂸɁI */

	/* ɏJ[\ݒ肵܂B */
	gi.cursor_col = 0;
	gi.cursor_row = PANEL_ROWS - 1;
	gi.panel[gi.cursor_row][gi.cursor_col].color = 0;

	/* NEXTpl𐶐܂B */
	next_gen();

	/*--------------- ubN ---------------*/

	gi.block_rows = ROUND_BLOCK_ROWS;
	gi.block_top = (BLOCK_ROWS - gi.block_rows) / 2;

	/* ubN̊e܂B
	 * sڂ̓~TCopAsڂ͋󔒁AOsڈȍ~ubNłB
	 */
	memset(gi.block, 0, sizeof gi.block);
	for(block = &gi.block[0], col = 0; col < BLOCK_COLS; col++, block++) {
		block->cnt = gi.block_rows - 2;
		block->mis_pos = -0x600; /* ~TCoʒu */
	}

	/* sibv摜܂B */
	texture_init(&gi.pinup, ROUND_PINUP);

	/*--------------- Aj[V ---------------*/

	gi.face = 0;
	gi.face_cnt = SEC(3);

#undef MAX_RETRY
}

/****************************************************************************
 *	next_gen
 ****************************************************************************/

void
next_gen()
{
#define MAX_RETRY	10

	int col, retry;
	PANEL* panel;

	memset(&gi.next, 0, sizeof gi.next);
	for(panel = &gi.next[PANEL_COLS - 1], col = PANEL_COLS - 1; col >= 0; col--, panel--) {
		for(retry = 0; retry < MAX_RETRY; retry++) {
			panel->color = RND(1, ROUND_COLOR);
			if(col > PANEL_COLS - 3) break;
			if(panel->color != (panel + 1)->color ||
			   panel->color != (panel + 2)->color) break;
		}
	}

#undef MAX_RETRY
}

/****************************************************************************
 *	next_in
 ****************************************************************************/

int
next_in()
{
	int col;
	PANEL* panel;

	/* ΂ɖZȊOAoł܂B */
	for(panel = &gi.panel[0][0], col = 0; col < PANEL_COLS; col++, panel++) {
		if(panel->color != -1) return 0;
	}

	/* pliɂ炵ANEXTubNŉiɏo܂B */
	memmove(&gi.panel[0][0], &gi.panel[1][0], sizeof(PANEL) * PANEL_COLS * (PANEL_ROWS - 1));
	memcpy(&gi.panel[PANEL_ROWS - 1][0], &gi.next[0], sizeof(PANEL) * PANEL_COLS);
	gi.cursor_row--; /* J[\iɈړ */

	/* NEXTubN𐶐܂B */
	next_gen();

	return 1;
}

/****************************************************************************
 *	round_demo
 ****************************************************************************/

void
round_demo()
{
	int i, x, y;

	memset(vbuff, 3, sizeof vbuff);
	x = (DISP_X - 4 * 7) / 2;
	y = (DISP_Y - 6    ) / 2;
	for(i = 0; i < SEC(0.25); i++) schedule(); /* EFCg */
	for(i = 0; i < 4 * 2; i++) { /* tF[hC */
		schedule();
		render_printf(&render, x, y, 0, 3 - i / 2, "ROUND%2d", gi.round);
	}
	for(i = 0; i < SEC(1); i++) { /* ҂ */
		schedule();
		render_printf(&render, x, y, 0, 0, "ROUND%2d", gi.round);
	}
	for(i = 0; i < 4 * 2; i++) { /* tF[hAEg */
		schedule();
		render_printf(&render, x, y, 0, i / 2, "ROUND%2d", gi.round);
	}
	for(i = 0; i < SEC(0.25); i++) schedule(); /* EFCg */
}

/****************************************************************************
 *	gameover_demo
 ****************************************************************************/

void
gameover_demo()
{
	int i, x, y;

	mod_play(GAMEOVER);

	memset(vbuff, 3, sizeof vbuff);
	x = (DISP_X - 4 * 9) / 2;
	y = (DISP_Y - 6    ) / 2;
	for(i = 0; i < SEC(0.25); i++) schedule(); /* EFCg */
	for(i = 0; i < 4 * 2; i++) { /* tF[hC */
		schedule();
		render_string(&render, x, y, "GAME OVER", 0, 3 - i / 2);
	}
	for(i = 0; i < SEC(4); i++) { /* ҂ */
		schedule();
		render_string(&render, x, y, "GAME OVER", 0, 0);
	}
	for(i = 0; i < 4 * 2; i++) { /* tF[hAEg */
		schedule();
		render_string(&render, x, y, "GAME OVER", 0, i / 2);
	}
	for(i = 0; i < SEC(0.25); i++) schedule(); /* EFCg */

	mod_stop();
}

/****************************************************************************
 *	chain_count
 ****************************************************************************/

/* w肳ꂽʒu0:E/1:ցAѐ𐔂܂B
 * ѐ̃`FbŃÃplEȄōŝƉ肵A
 * 荶̃pl_ƂČς݂łplɂẮAѐ0Ԃ܂B
 * ̂悤ɂŔAѐ4ȏ̃plт̉E()ʒu_ƂčČƁA
 * ̃pl4ƕ3œ񔻒肳Ă܂Ƃ邩łB
 * ܂A()̃plѐ2pĺAČĂѐ1Ɍ܂Ă̂ŁA
 * Ȃč邽߂łB
 */
int
chain_count(int col, int row, int dir)
{
	int color, mark, cnt;
	PANEL* panel;

	panel = &gi.panel[row][col];
	mark = 1 << dir;
	if(panel->mark & mark) return 0; /* ƍ()̃pl_ƂāAŌς */
	color = panel->color;
	if(color < 1) return 0; /* -1:Z or 0:J[\ */

	cnt = 0;
	for(;;) {
		if(panel->color != color) break;
		panel->mark |= mark; /* тɊ܂܂ꂽAŃ}[N܂ */
		cnt++;
		if(dir == 0) {
			col++;
			if(col > PANEL_COLS - 1) break;
			panel += 1;
		} else {
			row++;
			if(row > PANEL_ROWS - 1) break;
			panel += PANEL_COLS;
		}
	}
	return cnt;
}

/****************************************************************************
 *	erase_check
 ****************************************************************************/

int
erase_check()
{
	int result, i, col, row, cnt;
	PANEL *panel, *panel2;

	result = 0;
	for(panel = &gi.panel[0][0], row = 0; row < PANEL_ROWS; row++) {
		for(col = 0; col < PANEL_COLS; col++, panel++) {
			/* єB */
			cnt = chain_count(col, row, 0);
			if(cnt >= 3) {
				result++;
				for(panel2 = panel, i = 0; i < cnt; i++, panel2 += 1) {
					panel2->mark |= 0x80;
				}
				/* ҂~TCǉB */
				if(cnt == 3) { /* OтȂ^񒆂̗Ɉ */
					gi.block[col + 1].mis_stock++;
				} else { /* lшȏȂSĂ̗ɈÂ */
					for(i = 0; i < cnt; i++) gi.block[col + i].mis_stock++;
				}
				/* _ZB */
				if(cnt == 3) { /* OтȂ1_ */
					gi.score++;
				} else { /* l50_,܂100_,Z150_,... */
					gi.score += 5 * (cnt - 3);
				}
				if(gi.score > hiscore) hiscore = gi.score; /* nCXRAXV */
			}
			/* cєB */
			cnt = chain_count(col, row, 1);
			if(cnt >= 3) {
				result++;
				for(panel2 = panel, i = 0; i < cnt; i++, panel2 += PANEL_COLS) {
					panel2->mark |= 0x80;
				}
				/* ҂~TCǉB */
				if(cnt == 3) { /* OтȂ */
					gi.block[col].mis_stock++;
				} else { /* lшȏȂ񂾐 */
					gi.block[col].mis_stock += cnt;
				}
				/* _ZB */
				if(cnt == 3) { /* OтȂ1_ */
					gi.score++;
				} else { /* l50_,܂100_,Z150_,... */
					gi.score += 5 * (cnt - 3);
				}
				if(gi.score > hiscore) hiscore = gi.score; /* nCXRAXV */
			}
		}
	}
	mark_clr(0x7f); /* є}[NBŃ}[N͎c */

	return result;
}

/****************************************************************************
 *	erase_end
 ****************************************************************************/

int
erase_end()
{
	int result, col, row;
	PANEL *panel, *panel2;

	/* ܂łpl܂B */
	for(panel = &gi.panel[0][0], row = 0; row < PANEL_ROWS; row++) {
		for(col = 0; col < PANEL_COLS; col++, panel++) {
			if(!panel->mark) continue;
			panel->color = -1;
			panel->mark = 0;
		}
	}

	/* 󂫂łpl𗎂Ƃ܂B */
	result = 0;
REDO:
	for(panel = &gi.panel[0][0], row = 0; row < PANEL_ROWS - 1; row++) {
		for(col = 0; col < PANEL_COLS; col++, panel++) {
			panel2 = panel + PANEL_COLS;
			if(panel->color != -1 && panel2->color == -1) {
				*panel2 = *panel;
				panel->color = -1;
				panel->mark = 0;
				result++;
				goto REDO; /* ȂƏcɏłƂɂƗ܂ */
			}
		}
	}

	/* J[\ʒuXVB */
	for(panel = &gi.panel[0][0], row = 0; row < PANEL_ROWS; row++) {
		for(col = 0; col < PANEL_COLS; col++, panel++) {
			if(panel->color == 0) {
				gi.cursor_col = col;
				gi.cursor_row = row;
				return result;
			}
		}
	}
	DIE(); /* J[\HŗoOł */
	return 0; /* _~[ */
}

/****************************************************************************
 *	mark_clr
 ****************************************************************************/

/* SZ̃}[NNA܂B(mark̒"1"̃rbĝ) */
void
mark_clr(unsigned char mark)
{
	PANEL* panel;
	int col, row;

	mark = ~mark;
	for(panel = &gi.panel[0][0], row = 0; row < PANEL_ROWS; row++) {
		for(col = 0; col < PANEL_COLS; col++, panel++) {
			panel->mark &= mark;
		}
	}
}

/****************************************************************************
 *	missile_work
 ****************************************************************************/

int
missile_work()
{
	int cnt, col;
	BLOCK* block;

	cnt = 0;
	for(block = &gi.block[0], col = 0; col < BLOCK_COLS; col++, block++) {
		/*  */
		if(block->expl) {
			if(block->expl < 8 * 2 - 1) {
				block->expl++;
			} else {
				block->expl = 0;
			}
		}
		/* ~TC */
		switch(block->mis_stat) {
		case 0: /* o */
			block->mis_pos += 0x80;
			if(block->mis_pos >= 0) {
				block->mis_stat = 1; /* ҋ@ */
				block->mis_pos = 0;
			}
			break;
		case 1: /* ҋ@ */
			if(block->mis_stock > 0) {
				block->mis_stock--;
				block->mis_stat = 2; /*  */
				block->mis_speed = 0x80;
			}
			break;
		case 2: /*  */
			block->mis_pos += block->mis_speed;
			if(((block->mis_pos >> 8) + 4) / 7 >= gi.block_rows - block->cnt) { /* nH */
				if(block->cnt) block->cnt--; /* ubNj */
				block->expl = 1; /* Jn */
				cnt++; /* Ōʉ炷߂Ƀ}[N */
				block->mis_stat = 0; /* o */
				block->mis_pos = -0x600; /* ~TCoʒu */
			} else {
				block->mis_speed += 0x20;
				if(block->mis_speed > 0x200) block->mis_speed = 0x200;
			}
			break;
		default:
			DIE();
		}
	}
	if(cnt) sound_play(3, BLKEXP);

	/* cubNԂ܂B */
	cnt = 0;
	for(block = &gi.block[0], col = 0; col < BLOCK_COLS; col++, block++) {
		cnt += block->cnt;
	}
	return cnt;
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

/*---------- ]W ----------*/
#define PANEL_DX	 4
#define PANEL_DY	 0

#define NEXTP_DX	 4
#define NEXTP_DY	81

#define NEXT_DX		16
#define NEXT_DY		77

#define BLOCK_DX	82
#define BLOCK_DY	 0

#define HISCORE_DX	51
#define HISCORE_DY	11

#define SCORE_DX	51
#define SCORE_DY	28

#define LEVEL_DX	71
#define LEVEL_DY	34

#define ROUND_DX	71
#define ROUND_DY	45

#define LIFE_DX		51
#define LIFE_DY		51

#define FACE_DX		52
#define FACE_DY		60

/*---------- ]W(pat/pat2) ----------*/
#define PANEL_SX	0
#define PANEL_SY	0

#define NEXT_SX		72
#define NEXT_SY		 0

#define LIFE_SX		96
#define LIFE_SY		 0

#define FACE_SX		 0
#define FACE_SY		32

#define MISSILE_SX	104
#define MISSILE_SY	  0

#define MASK_SX		112
#define MASK_SY		  0

#define BLOCK_SX	120
#define BLOCK_SY	  0

#define EXPR_SX		72
#define EXPR_SY		32

static unsigned char cursor_pat[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 0,0,0,0,0,0,0,0,0,0,0,0,0,1,2,1};
#define CURSOR_PAT_SIZE	(sizeof cursor_pat / sizeof *cursor_pat)

void
field_disp()
{
	int i, col, row, dx, dy, sx, sy;
	PANEL* panel;
	BLOCK* block;

	/* wi\܂B
	 * 2002/11/19ȍ~A8sNZE]̍ÔŁA
	 *   炩߃obt@ɓWJĂāAmemcpyœ]B
	 *   iɗ]T΂܂傤j
	 */
	render.context->texture = &bg;
	render_object(&render, 0, 0, 0, 0, DISP_X, DISP_Y, DRW_NOMAL);

	/*--------------- CtH[V\ ---------------*/

	render.context->texture = &pat2; /* }XNȂ */

	/* XRAȂǕ\B */
	render_printf(&render, HISCORE_DX, HISCORE_DY, 2, 0, "%6d", hiscore <= 999999 ? hiscore : 999999);
	render_printf(&render, SCORE_DX, SCORE_DY, 2, 0, "%6d", gi.score <= 999999 ? gi.score : 999999);
	render_printf(&render, LEVEL_DX, LEVEL_DY, 2, 0, "%2d", gi.round <= 99 ? gi.round : 99);
	render_printf(&render, ROUND_DX, ROUND_DY, 2, 0, "%2d", gi.round <= 99 ? gi.round : 99);

	/* c@\B */
	dx = LIFE_DX;
	dy = LIFE_DY;
	for(i = 0; i < gi.life; i++) {
		render_object(&render, dx, dy, LIFE_SX, LIFE_SY, 7, 7, DRW_NOMAL);
		dx += 8;
	}

	/* \B */
	sx = FACE_SX + 24 * (gi.face / 4);
	sy = FACE_SY + 24 * (gi.face % 4);
	render_object(&render, FACE_DX, FACE_DY, sx, sy, 24, 24, DRW_NOMAL);

	/*--------------- pl\ ---------------*/

	/* tB[h̃pl\܂B */
	for(row = 0, panel = &gi.panel[0][0]; row < PANEL_ROWS; row++) {
		for(col = 0; col < PANEL_COLS; col++, panel++) {
			if(panel->color == -1) continue; /* Z */
			dx = PANEL_DX + col * 7;
			dy = PANEL_DY + row * 7;
			sx = PANEL_SX + panel->color * 8;
			sy = PANEL_SY;
			if(!panel->mark) {
				render.context->texture = &pat2; /* }XNȂ */
				if(panel->color == 0) {
					render_object(&render, dx, dy, PANEL_SX, PANEL_SY + cursor_pat[now % CURSOR_PAT_SIZE] * 8, 7, 7, DRW_NOMAL);
				} else {
					render_object(&render, dx, dy, sx, sy, 7, 7, DRW_NOMAL);
				}
			} else {
				render.context->texture = &pat; /* }XN */
				switch(gi.phase) {
				case PHASE_MOVE_LF:
					if(panel->color) {
						render_object(&render, dx + 7, dy, PANEL_SX, PANEL_SY + cursor_pat[now % CURSOR_PAT_SIZE] * 8, 7, 7, DRW_NOMAL);
						render_object(&render, dx    , dy, PANEL_SX, PANEL_SY + cursor_pat[now % CURSOR_PAT_SIZE] * 8, 7, 7, DRW_NOMAL);
						if(gi.cnt < 6) dx += 6 - gi.cnt;
						render_object(&render, dx, dy, sx, sy, 7, 7, DRW_NOMAL);
					}
					break;
				case PHASE_MOVE_RI:
					if(panel->color) {
						render_object(&render, dx - 7, dy, PANEL_SX, PANEL_SY + cursor_pat[now % CURSOR_PAT_SIZE] * 8, 7, 7, DRW_NOMAL);
						render_object(&render, dx    , dy, PANEL_SX, PANEL_SY + cursor_pat[now % CURSOR_PAT_SIZE] * 8, 7, 7, DRW_NOMAL);
						if(gi.cnt < 6) dx -= 6 - gi.cnt;
						render_object(&render, dx, dy, sx, sy, 7, 7, DRW_NOMAL);
					}
					break;
				case PHASE_MOVE_UP:
					if(panel->color) {
						render_object(&render, dx, dy + 7, PANEL_SX, PANEL_SY + cursor_pat[now % CURSOR_PAT_SIZE] * 8, 7, 7, DRW_NOMAL);
						render_object(&render, dx, dy    , PANEL_SX, PANEL_SY + cursor_pat[now % CURSOR_PAT_SIZE] * 8, 7, 7, DRW_NOMAL);
						if(gi.cnt < 6) dy += 6 - gi.cnt;
						render_object(&render, dx, dy, sx, sy, 7, 7, DRW_NOMAL);
					}
					break;
				case PHASE_MOVE_DN:
					if(panel->color) {
						render_object(&render, dx, dy - 7, PANEL_SX, PANEL_SY + cursor_pat[now % CURSOR_PAT_SIZE] * 8, 7, 7, DRW_NOMAL);
						render_object(&render, dx, dy    , PANEL_SX, PANEL_SY + cursor_pat[now % CURSOR_PAT_SIZE] * 8, 7, 7, DRW_NOMAL);
						if(gi.cnt < 6) dy -= 6 - gi.cnt;
						render_object(&render, dx, dy, sx, sy, 7, 7, DRW_NOMAL);
					}
					break;
				case PHASE_ERASE:
					if(gi.cnt < 4 * 2) {
						sy += 8 * (gi.cnt / 2);
						render_object(&render, dx, dy, sx, sy, 7, 7, DRW_NOMAL);
					}
					break;
				default:
					DIE();
				}
			}
		}
	}

	/* NEXTpl\܂B */
	render.context->texture = &pat2; /* }XNȂ */
	for(panel = &gi.next[0], col = 0; col < PANEL_COLS; col++, panel++) {
		dx = NEXTP_DX + col * 7;
		dy = NEXTP_DY;
		sx = PANEL_SX + panel->color * 8;
		sy = PANEL_SY;
		render_object(&render, dx, dy, sx, sy, 7, 7, DRW_NOMAL);
	}

	/* NEXT\܂B */
	render.context->texture = &pat2; /* }XNȂ */
	dx = NEXT_DX;
	dy = NEXT_DY;
	sx = NEXT_SX;
	sy = NEXT_SY;
	if(gi.next_cnt >= gi.next_time - NEXT_WARN_TIME) {
		if(now & 1) sy += 4;
	}
	render_object(&render, dx, dy, sx, sy, 17, 4, DRW_NOMAL);

	/*--------------- ubN\ ---------------*/

	/* }XN\܂B */
	render.context->texture = &pat2; /* }XNȂ */
	for(dy = BLOCK_DY,
	    row = 0; row < gi.block_top; row++, dy += 7) {
		for(dx = BLOCK_DX, col = 0; col < BLOCK_COLS; col++, dx += 7) {
			render_object(&render, dx, dy, MASK_SX, MASK_SY, 7, 7, DRW_NOMAL);
		}
	}
	for(dy = BLOCK_DY + 7 * (gi.block_top + gi.block_rows),
	    row = gi.block_top + gi.block_rows; row < BLOCK_ROWS; row++, dy += 7) {
		for(dx = BLOCK_DX, col = 0; col < BLOCK_COLS; col++, dx += 7) {
			render_object(&render, dx, dy, MASK_SX, MASK_SY, 7, 7, DRW_NOMAL);
		}
	}

	/* sibv\܂B */
	render.context->texture = &gi.pinup;
	dx = BLOCK_DX;
	dy = BLOCK_DY + 7 * (gi.block_top + 2);
	render_object(&render, dx, dy, 0, 0, 7 * BLOCK_COLS, 7 * (gi.block_rows - 2), DRW_NOMAL);

	/* ubN\܂B */
	render.context->texture = &pat2; /* }XNȂ */
	for(block = &gi.block[0], dx = BLOCK_DX, col = 0; col < BLOCK_COLS; col++, dx += 7, block++) {
		for(dy = BLOCK_DY + 7 * (gi.block_top + gi.block_rows - 1), i = 0; i < block->cnt; i++, dy -= 7) {
			render_object(&render, dx, dy, BLOCK_SX, BLOCK_SY, 7, 7, DRW_NOMAL);
		}
	}

	/* ~TC\܂B */
	render.context->texture = &pat; /* }XN */
	render.top = BLOCK_DY + 7 * gi.block_top; /* o~TC̏㑤NbsO */
	for(block = &gi.block[0], dx = BLOCK_DX, col = 0; col < BLOCK_COLS; col++, dx += 7, block++) {
		dy = BLOCK_DY + 7 * gi.block_top + (block->mis_pos >> 8);
		render_object(&render, dx, dy, MISSILE_SX, MISSILE_SY, 7, 7, DRW_NOMAL);
	}
	render.top = 0; /* NbsO */

	/* \܂B */
	render.context->texture = &pat; /* }XN */
	for(block = &gi.block[0], dx = BLOCK_DX, col = 0; col < BLOCK_COLS; col++, dx += 7, block++) {
		if(!block->expl) continue;
		dy = BLOCK_DY + 7 * (gi.block_top + gi.block_rows - 1 - block->cnt); /* cĂubN̈オƑz */
		if(block->expl < 8 * 2) {
			sx = EXPR_SX + 24 * (block->expl / 2 / 4);
			sy = EXPR_SY + 24 * (block->expl / 2 % 4);
			render_object(&render, dx - 7, dy - 7, sx, sy, 21, 21, DRW_NOMAL);
		}
	}
}

/****************************************************************************
 *	miss_demo
 ****************************************************************************/

void
miss_demo()
{
	typedef struct _PP {
		char color;
		short x, y;	/* 8.8bit */
		short vx, vy;	/* 8.8bit */
	} PP;
	PP (*pp)[PANEL_COLS], *p;
	PANEL* panel;
	int i, col, row, dx, dy, sx, sy;

	sound_play(1, PANMIS);

	/* plǗpzmۂ܂B */
	pp = (PP (*)[PANEL_COLS])calloc(PANEL_COLS * PANEL_ROWS, sizeof(PP));
	if(pp == NULL) DIE();

	/* cĂplǗpzɈڂAʒuEx܂B */
	for(panel = &gi.panel[0][0], p = &pp[0][0], row = 0; row < PANEL_ROWS; row++) {
		for(col = 0; col < PANEL_COLS; col++, panel++, p++) {
			if(panel->color >= 1) {
				p->color = panel->color;
				p->x = (PANEL_DX + col * 7) << 8;
				p->y = (PANEL_DY + row * 7) << 8;
				p->vx = (col - PANEL_COLS / 2) * 0x80 + 0x40;
				p->vy = (row - PANEL_ROWS / 2) * 0x80;
			}
			panel->color = -1; /* {̃pl͏ */
			panel->mark = 0;
		}
	}

	render.context->texture = &pat2; /* }XNȂ */
	for(i = 0; i < SEC(3); i++) {
		schedule();
		/* ʏ̃tB[h\B */
		field_disp();
		/* Ct_ŕ\BiɃCt͌Ă܂j */
		if(i % SEC(1) >= SEC(0.5)) {
			dx = LIFE_DX + gi.life * 8;
			dy = LIFE_DY;
			render_object(&render, dx, dy, LIFE_SX, LIFE_SY, 7, 7, DRW_NOMAL);
		}
		/* bZ[W\B */
		dx = PANEL_DX +  7;
		dy = PANEL_DY + 34;
		render_rectangle_fill(&render, dx, dy, 28, 9, 3);
		render_string(&render, dx + 2, dy + 2, "MISS..", 2, 0);
		/* pl\B */
		for(p = &pp[0][0], row = 0; row < PANEL_ROWS; row++) {
			for(col = 0; col < PANEL_COLS; col++, p++) {
				if(!p->color) continue;
				sx = PANEL_SX + p->color * 8;
				sy = PANEL_SY;
				render_object(&render, p->x >> 8, p->y >> 8, sx, sy, 7, 7, DRW_NOMAL);
				p->x += p->vx;
				p->y += p->vy;
				p->vy += 0x80;
				if(p->x >> 8 <= -7 ||   DISP_X <= p->x >> 8 ||
				 /*p->y >> 8 <= -7 ||*/ DISP_Y <= p->y >> 8) p->color = 0;
			}
		}
	}

	/* plǗpzJ܂B */
	free(pp);
}

/****************************************************************************
 *	clear_demo
 ****************************************************************************/

void
clear_demo()
{
	int i, col, dx, dy;
	BLOCK* block;

	mod_play(CLEAR);

	/* ҂~TCcĂLZB
	 * ɗ̃~TĆAfp܂
	 */
	for(block = &gi.block[0], col = 0; col < BLOCK_COLS; col++, block++) {
		block->mis_stock = 0;
	}

	for(i = 0; i < SEC(3); i++) {
		schedule();
		missile_work(); /* ̃~TC͌p܂ */
		/* ʏ̃tB[h\B */
		field_disp();
		/* bZ[W\B */
		dx = PANEL_DX +  7;
		dy = PANEL_DY + 30;
		render_rectangle_fill(&render, dx, dy, 28, 15, 3);
		render_string(&render, dx + 2, dy + 2, "ROUND \nCLEAR!", 2, 0);
	}

	mod_play(GAME2);
}

